Index: arch/sparc/mm/generic.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/generic.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/generic.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/generic.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: generic.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: generic.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * generic.c: Generic Sparc mm routines that are not dependent upon
  *            MMU type but are Sparc specific.
  *
Index: arch/sparc/mm/hypersparc.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/hypersparc.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/hypersparc.S	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/hypersparc.S	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: hypersparc.S,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: hypersparc.S,v 1.2 2004/08/04 01:26:15 joff Exp $
  * hypersparc.S: High speed Hypersparc mmu/cache operations.
  *
  * Copyright (C) 1997 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/mm/init.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/init.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/init.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/init.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/*  $Id: init.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/*  $Id: init.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  *  linux/arch/sparc/mm/init.c
  *
  *  Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/mm/io-unit.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/io-unit.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/io-unit.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/io-unit.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: io-unit.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: io-unit.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * io-unit.c:  IO-UNIT specific routines for memory management.
  *
  * Copyright (C) 1997,1998 Jakub Jelinek    (jj@sunsite.mff.cuni.cz)
Index: arch/sparc/mm/iommu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/iommu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/iommu.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/iommu.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: iommu.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: iommu.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * iommu.c:  IOMMU specific routines for memory management.
  *
  * Copyright (C) 1995 David S. Miller  (davem@caip.rutgers.edu)
Index: arch/sparc/mm/loadmmu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/loadmmu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/loadmmu.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/loadmmu.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: loadmmu.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: loadmmu.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * loadmmu.c:  This code loads up all the mm function pointers once the
  *             machine type has been determined.  It also sets the static
  *             mmu values such as PAGE_NONE, etc.
Index: arch/sparc/mm/nosrmmu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/nosrmmu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/nosrmmu.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/nosrmmu.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: nosrmmu.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: nosrmmu.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * nosrmmu.c: This file is a bunch of dummies for sun4 compiles, 
  *         so that it does not need srmmu and avoid ifdefs.
  *
Index: arch/sparc/mm/nosun4c.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/nosun4c.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/nosun4c.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/nosun4c.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: nosun4c.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: nosun4c.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * nosun4c.c: This file is a bunch of dummies for SMP compiles, 
  *         so that it does not need sun4c and avoid ifdefs.
  *
Index: arch/sparc/mm/srmmu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/srmmu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/srmmu.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/srmmu.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: srmmu.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: srmmu.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * srmmu.c:  SRMMU specific routines for memory management.
  *
  * Copyright (C) 1995 David S. Miller  (davem@caip.rutgers.edu)
@@ -126,6 +126,9 @@
 
 #define SRMMU_NOCACHE_BITMAP_SHIFT (PAGE_SHIFT - 4)
 
+/* The context table is a nocache user with the biggest alignment needs. */
+#define SRMMU_NOCACHE_ALIGN_MAX (sizeof(ctxd_t)*SRMMU_MAX_CONTEXTS)
+
 void *srmmu_nocache_pool;
 void *srmmu_nocache_bitmap;
 int srmmu_nocache_low;
@@ -260,6 +263,7 @@
 
 	/* we align on physical address */
 	if (align) {
+		BUG_ON(align > SRMMU_NOCACHE_ALIGN_MAX);
 		va_tmp = (SRMMU_NOCACHE_VADDR + (offset << SRMMU_NOCACHE_BITMAP_SHIFT));
 		phys_tmp = (__nocache_pa(va_tmp) + align - 1) & ~(align - 1);
 		va_tmp = (unsigned long)__nocache_va(phys_tmp);
@@ -367,7 +371,8 @@
 	unsigned long paddr, vaddr;
 	unsigned long pteval;
 
-	srmmu_nocache_pool = __alloc_bootmem(srmmu_nocache_size, PAGE_SIZE, 0UL);
+	srmmu_nocache_pool = __alloc_bootmem(srmmu_nocache_size,
+		SRMMU_NOCACHE_ALIGN_MAX, 0UL);
 	memset(srmmu_nocache_pool, 0, srmmu_nocache_size);
 
 	srmmu_nocache_bitmap = __alloc_bootmem(srmmu_nocache_bitmap_size, SMP_CACHE_BYTES, 0UL);
Index: arch/sparc/mm/sun4c.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/sun4c.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/sun4c.c	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/sun4c.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: sun4c.c,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: sun4c.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * sun4c.c: Doing in software what should be done in hardware.
  *
  * Copyright (C) 1996 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/mm/swift.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/swift.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/swift.S	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/swift.S	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: swift.S,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: swift.S,v 1.2 2004/08/04 01:26:15 joff Exp $
  * swift.S: MicroSparc-II mmu/cache operations.
  *
  * Copyright (C) 1999 David S. Miller (davem@redhat.com)
Index: arch/sparc/mm/tsunami.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/tsunami.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/tsunami.S	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/tsunami.S	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: tsunami.S,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: tsunami.S,v 1.2 2004/08/04 01:26:15 joff Exp $
  * tsunami.S: High speed MicroSparc-I mmu/cache operations.
  *
  * Copyright (C) 1997 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/mm/viking.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/mm/viking.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/mm/viking.S	22 Jul 2004 19:49:20 -0000	1.1
+++ arch/sparc/mm/viking.S	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: viking.S,v 1.1 2004/07/22 19:49:20 joff Exp $
+/* $Id: viking.S,v 1.2 2004/08/04 01:26:15 joff Exp $
  * viking.S: High speed Viking cache/mmu operations
  *
  * Copyright (C) 1997  Eddie C. Dost  (ecd@skynet.be)
Index: arch/sparc/prom/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/Makefile	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/Makefile	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:15 joff Exp $
 # Makefile for the Sun Boot PROM interface library under
 # Linux.
 #
Index: arch/sparc/prom/bootstr.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/bootstr.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/bootstr.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/bootstr.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: bootstr.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: bootstr.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * bootstr.c:  Boot string/argument acquisition from the PROM.
  *
  * Copyright(C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/prom/console.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/console.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/console.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/console.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: console.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: console.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * console.c: Routines that deal with sending and receiving IO
  *            to/from the current console device using the PROM.
  *
Index: arch/sparc/prom/devmap.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/devmap.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/devmap.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/devmap.c	4 Aug 2004 01:26:15 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: devmap.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: devmap.c,v 1.2 2004/08/04 01:26:15 joff Exp $
  * promdevmap.c:  Map device/IO areas to virtual addresses.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/prom/devops.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/devops.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/devops.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/devops.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: devops.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: devops.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * devops.c:  Device operations using the PROM.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/prom/init.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/init.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/init.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/init.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: init.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: init.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * init.c:  Initialize internal variables used by the PROM
  *          library functions.
  *
Index: arch/sparc/prom/memory.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/memory.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/memory.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/memory.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: memory.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: memory.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * memory.c: Prom routine for acquiring various bits of information
  *           about RAM on the machine, both virtual and physical.
  *
Index: arch/sparc/prom/misc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/misc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/misc.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/misc.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: misc.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: misc.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * misc.c:  Miscellaneous prom functions that don't belong
  *          anywhere else.
  *
Index: arch/sparc/prom/mp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/mp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/mp.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/mp.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: mp.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: mp.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * mp.c:  OpenBoot Prom Multiprocessor support routines.  Don't call
  *        these on a UP or else you will halt and catch fire. ;)
  *
Index: arch/sparc/prom/palloc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/palloc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/palloc.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/palloc.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: palloc.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: palloc.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * palloc.c:  Memory allocation from the Sun PROM.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/prom/ranges.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/ranges.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/ranges.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/ranges.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ranges.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: ranges.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * ranges.c: Handle ranges in newer proms for obio/sbus.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc/prom/segment.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/segment.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/segment.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/segment.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: segment.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: segment.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * segment.c:  Prom routine to map segments in other contexts before
  *             a standalone is completely mapped.  This is for sun4 and
  *             sun4c architectures only.
Index: arch/sparc/prom/tree.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc/prom/tree.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc/prom/tree.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc/prom/tree.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: tree.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: tree.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * tree.c: Basic device tree traversal/scanning for the Linux
  *         prom library.
  *
Index: arch/sparc64/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/Makefile	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/Makefile	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:16 joff Exp $
 # sparc64/Makefile
 #
 # Makefile for the architecture dependent flags and dependencies on the
Index: arch/sparc64/config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/config.in	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/config.in	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: config.in,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: config.in,v 1.2 2004/08/04 01:26:16 joff Exp $
 # For a description of the syntax of this configuration file,
 # see the Configure script.
 #
@@ -28,6 +28,10 @@
 
 bool 'Symmetric multi-processing support' CONFIG_SMP
 
+if [ "$CONFIG_SMP" = "y" ]; then
+   int  'Maximum number of CPUs (2-32)' CONFIG_NR_CPUS 32
+fi
+
 # Identify this as a Sparc64 build
 define_bool CONFIG_SPARC64 y
 
@@ -79,6 +83,7 @@
 if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
    tristate 'Solaris binary emulation (EXPERIMENTAL)' CONFIG_SOLARIS_EMUL
 fi
+bool 'Select task to kill on out of memory condition' CONFIG_OOM_KILLER
 source drivers/parport/Config.in
 dep_tristate '  Parallel printer support' CONFIG_PRINTER $CONFIG_PARPORT
 if [ "$CONFIG_PCI" = "y" ]; then
@@ -128,7 +133,6 @@
 if [ "$CONFIG_IDE" != "n" ]; then
   source drivers/ide/Config.in
 else
-  define_bool CONFIG_BLK_DEV_IDE_MODES n
   define_bool CONFIG_BLK_DEV_HD n
 fi
 endmenu
@@ -235,7 +239,7 @@
    bool 'Network device support' CONFIG_NETDEVICES
    if [ "$CONFIG_NETDEVICES" = "y" ]; then
       source drivers/net/Config.in
-      if [ "$CONFIG_ATM" = "y" ]; then
+      if [ "$CONFIG_ATM" = "y" -o "$CONFIG_ATM" = "m" ]; then
 	source drivers/atm/Config.in
       fi
    fi
@@ -302,12 +306,16 @@
    bool '  Spinlock debugging' CONFIG_DEBUG_SPINLOCK
    bool '  Verbose BUG() reporting (adds 70K)' CONFIG_DEBUG_BUGVERBOSE
    bool '  D-cache flush debugging' CONFIG_DEBUG_DCFLUSH
+   bool '  Debug BOOTMEM initialization' CONFIG_DEBUG_BOOTMEM
 fi
 bool 'Stack Overflow Detection Support' CONFIG_STACK_DEBUG
 if [ "$CONFIG_STACK_DEBUG" = "y" ] ; then
    define_bool CONFIG_MCOUNT y
 fi
 
+int 'Kernel messages buffer length shift (0 = default)' CONFIG_LOG_BUF_SHIFT 0
+
 endmenu
 
+source crypto/Config.in
 source lib/Config.in
Index: arch/sparc64/boot/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/boot/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/boot/Makefile	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/boot/Makefile	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:16 joff Exp $
 # Makefile for the Sparc64 boot stuff.
 #
 # Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
@@ -20,7 +20,7 @@
 	$(HOSTCC) $(HOSTCFLAGS) -o piggyback piggyback.c
 
 image: $(TOPDIR)/vmlinux
-	$(STRIP) -R .comment -R .note $(TOPDIR)/vmlinux -o $@
+	$(STRIP) -R .comment -R .note -K sun4u_init -K _end -K _start $(TOPDIR)/vmlinux -o $@
 
 dep:
 
Index: arch/sparc64/boot/piggyback.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/boot/piggyback.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/boot/piggyback.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/boot/piggyback.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: piggyback.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: piggyback.c,v 1.2 2004/08/04 01:26:16 joff Exp $
    Simple utility to make a single-image install kernel with initial ramdisk
    for Sparc64 tftpbooting without need to set up nfs.
    
Index: arch/sparc64/kernel/central.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/central.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/central.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/central.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: central.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: central.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * central.c: Central FHC driver for Sunfire/Starfire/Wildfire.
  *
  * Copyright (C) 1997, 1999 David S. Miller (davem@redhat.com)
Index: arch/sparc64/kernel/check_asm.sh
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/check_asm.sh,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/check_asm.sh	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/check_asm.sh	4 Aug 2004 01:26:16 -0000	1.2
@@ -11,7 +11,7 @@
     echo "	sizeof(struct $2_struct)," >> $4
   ;;
   -ints)
-    sed -n -e '/check_asm_data:/,/\.size/p' <$2 | sed -e 's/check_asm_data://' -e 's/\.size.*//' -e 's/\.long[		]\([0-9]*\)/\1,/' | grep -v '\.ident' >>$3
+    sed -n -e '/check_asm_data:/,/\.size/p' <$2 | sed -e 's/check_asm_data://' -e 's/\.size.*//' -e 's/\.section.*//' -e 's/\.long[		]\([0-9]*\)/\1,/' | grep -v '\.ident' >>$3
   ;;
   *)
     exit 1
Index: arch/sparc64/kernel/chmc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/chmc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/chmc.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/chmc.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: chmc.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: chmc.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * memctrlr.c: Driver for UltraSPARC-III memory controller.
  *
  * Copyright (C) 2001 David S. Miller (davem@redhat.com)
Index: arch/sparc64/kernel/cpu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/cpu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/cpu.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/cpu.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -37,6 +37,7 @@
   { 0x17, 0x13, 0, "UltraSparc IIe integrated FPU"},
   { 0x3e, 0x14, 0, "UltraSparc III integrated FPU"},
   { 0x3e, 0x15, 0, "UltraSparc III+ integrated FPU"},
+  { 0x3e, 0x16, 0, "UltraSparc IIIi integrated FPU"},
 };
 
 #define NSPARCFPU  (sizeof(linux_sparc_fpu)/sizeof(struct cpu_fp_info))
@@ -45,31 +46,25 @@
   { 0x17, 0x10, "TI UltraSparc I   (SpitFire)"},
   { 0x22, 0x10, "TI UltraSparc I   (SpitFire)"},
   { 0x17, 0x11, "TI UltraSparc II  (BlackBird)"},
-  { 0x17, 0x12, "TI UltraSparc IIi"},
-  { 0x17, 0x13, "TI UltraSparc IIe"},
+  { 0x17, 0x12, "TI UltraSparc IIi (Sabre)"},
+  { 0x17, 0x13, "TI UltraSparc IIe (Hummingbird)"},
   { 0x3e, 0x14, "TI UltraSparc III (Cheetah)"},
   { 0x3e, 0x15, "TI UltraSparc III+ (Cheetah+)"},
+  { 0x3e, 0x16, "TI UltraSparc IIIi (Jalapeno)"},
 };
 
 #define NSPARCCHIPS  (sizeof(linux_sparc_chips)/sizeof(struct cpu_iu_info))
 
-#ifdef CONFIG_SMP
-char *sparc_cpu_type[64] = { "cpu-oops", "cpu-oops1", "cpu-oops2", "cpu-oops3" };
-char *sparc_fpu_type[64] = { "fpu-oops", "fpu-oops1", "fpu-oops2", "fpu-oops3" };
-#else
-char *sparc_cpu_type[64] = { "cpu-oops", };
-char *sparc_fpu_type[64] = { "fpu-oops", };
-#endif
+char *sparc_cpu_type = "cpu-oops";
+char *sparc_fpu_type = "fpu-oops";
 
 unsigned int fsr_storage;
 
 void __init cpu_probe(void)
 {
 	unsigned long ver, fpu_vers, manuf, impl, fprs;
-	int i, cpuid;
+	int i;
 	
-	cpuid = hard_smp_processor_id();
-
 	fprs = fprs_read();
 	fprs_write(FPRS_FEF);
 	__asm__ __volatile__ ("rdpr %%ver, %0; stx %%fsr, [%1]"
@@ -86,7 +81,7 @@
 	for (i = 0; i < NSPARCCHIPS; i++) {
 		if (linux_sparc_chips[i].manuf == manuf) {
 			if (linux_sparc_chips[i].impl == impl) {
-				sparc_cpu_type[cpuid]
+				sparc_cpu_type
 					= linux_sparc_chips[i].cpu_name;
 				break;
 			}
@@ -105,14 +100,14 @@
 			printk("DEBUG: manuf[%lx] impl[%lx]\n",
 			       manuf, impl);
 		}
-		sparc_cpu_type[cpuid] = "Unknown CPU";
+		sparc_cpu_type = "Unknown CPU";
 	}
 
 	for (i = 0; i < NSPARCFPU; i++) {
 		if (linux_sparc_fpu[i].manuf == manuf &&
 		    linux_sparc_fpu[i].impl == impl) {
 			if (linux_sparc_fpu[i].fpu_vers == fpu_vers) {
-				sparc_fpu_type[cpuid]
+				sparc_fpu_type
 					= linux_sparc_fpu[i].fp_name;
 				break;
 			}
@@ -122,6 +117,6 @@
 	if (i == NSPARCFPU) {
 		printk("DEBUG: manuf[%lx] impl[%lx] fsr.vers[%lx]\n",
 		       manuf, impl, fpu_vers);
-		sparc_fpu_type[cpuid] = "Unknown FPU";
+		sparc_fpu_type = "Unknown FPU";
 	}
 }
Index: arch/sparc64/kernel/dtlb_backend.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/dtlb_backend.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/dtlb_backend.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/dtlb_backend.S	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: dtlb_backend.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: dtlb_backend.S,v 1.2 2004/08/04 01:26:16 joff Exp $
  * dtlb_backend.S: Back end to DTLB miss replacement strategy.
  *                 This is included directly into the trap table.
  *
Index: arch/sparc64/kernel/dtlb_base.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/dtlb_base.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/dtlb_base.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/dtlb_base.S	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: dtlb_base.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: dtlb_base.S,v 1.2 2004/08/04 01:26:16 joff Exp $
  * dtlb_base.S:	Front end to DTLB miss replacement strategy.
  *              This is included directly into the trap table.
  *
Index: arch/sparc64/kernel/dtlb_prot.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/dtlb_prot.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/dtlb_prot.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/dtlb_prot.S	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: dtlb_prot.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: dtlb_prot.S,v 1.2 2004/08/04 01:26:16 joff Exp $
  * dtlb_prot.S: DTLB protection trap strategy.
  *              This is included directly into the trap table.
  *
Index: arch/sparc64/kernel/ebus.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/ebus.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/ebus.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/ebus.c	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ebus.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: ebus.c,v 1.2 2004/08/04 01:26:16 joff Exp $
  * ebus.c: PCI to EBus bridge device.
  *
  * Copyright (C) 1997  Eddie C. Dost  (ecd@skynet.be)
@@ -177,7 +177,8 @@
 
 static int __init child_regs_nonstandard(struct linux_ebus_device *dev)
 {
-	if (!strcmp(dev->prom_name, "i2c"))
+	if (!strcmp(dev->prom_name, "i2c") ||
+	    !strcmp(dev->prom_name, "SUNW,lombus"))
 		return 1;
 	return 0;
 }
Index: arch/sparc64/kernel/entry.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/entry.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/entry.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/entry.S	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: entry.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: entry.S,v 1.2 2004/08/04 01:26:16 joff Exp $
  * arch/sparc64/kernel/entry.S:  Sparc64 trap low-level entry points.
  *
  * Copyright (C) 1995,1997 David S. Miller (davem@caip.rutgers.edu)
@@ -911,10 +911,15 @@
 	sllx		%g1, 63, %g2;					\
 	or		%g4, %g2, %g4;					\
 	/* Get log entry pointer for this cpu at this trap level. */	\
+	BRANCH_IF_JALAPENO(g2,g3,50f)					\
 	ldxa		[%g0] ASI_SAFARI_CONFIG, %g2;			\
 	srlx		%g2, 17, %g2;					\
-	and		%g2, 0x3ff, %g2;				\
-	sllx		%g2, 9, %g2;					\
+	ba,pt		%xcc, 60f; 					\
+	 and		%g2, 0x3ff, %g2;				\
+50:	ldxa		[%g0] ASI_JBUS_CONFIG, %g2;			\
+	srlx		%g2, 17, %g2;					\
+	and		%g2, 0x1f, %g2;					\
+60:	sllx		%g2, 9, %g2;					\
 	sethi		%hi(cheetah_error_log), %g3;			\
 	ldx		[%g3 + %lo(cheetah_error_log)], %g3;		\
 	brz,pn		%g3, 80f;					\
@@ -1749,8 +1754,8 @@
 	cmp		%o0, -ENOIOCTLCMD
 	sllx		%g2, 32, %g2
 	bgeu,pn		%xcc, 1f
-
 	 andcc		%l0, 0x02, %l6	
+80:
 	andn		%g3, %g2, %g3		/* System call success, clear Carry condition code. */
 	stx		%g3, [%sp + PTREGS_OFF + PT_V9_TSTATE]	
 	bne,pn		%icc, linux_syscall_trace2
@@ -1760,9 +1765,21 @@
 	 stx		%l2, [%sp + PTREGS_OFF + PT_V9_TNPC]
 
 1:
+	/* Really a failure?  Check if force_successful_syscall_return()
+	 * was invoked.
+	 */
+	ldx		[%curptr + AOFF_task_thread + AOFF_thread_flags], %l0
+	andcc		%l0, SPARC_FLAG_SYS_SUCCESS, %g0
+	be,pt		%icc, 1f
+	 andcc		%l6, 0x02, %g0
+	andn		%l0, SPARC_FLAG_SYS_SUCCESS, %l0
+	ba,pt		%xcc, 80b
+	 stx		%l0, [%curptr + AOFF_task_thread + AOFF_thread_flags]
+
 	/* System call failure, set Carry condition code.
 	 * Also, get abs(errno) to return to the process.
 	 */
+1:
 	sub		%g0, %o0, %o0
 	or		%g3, %g2, %g3
 	stx		%o0, [%sp + PTREGS_OFF + PT_V9_I0]
Index: arch/sparc64/kernel/etrap.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/kernel/etrap.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/kernel/etrap.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/kernel/etrap.S	4 Aug 2004 01:26:16 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: etrap.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: etrap.S,v 1.2 2004/08/04 01:26:16 joff Exp $
  * etrap.S: Preparing for entry into the kernel on Sparc V9.
  *
  * Copyright (C) 1996, 1997 David S. Miller (davem@caip.rutgers.edu)
